#
# For Python version > = 2.7.8
# control all 8 digital output bits plugin for ALICE
#
from Tkinter import *
import libpysmu
from pysmu import *
# define button actions
def sel():
    global devx, DevID, bsw1
    # sending 0x50 = set to 0, 0x51 = set to 1
    if D0.get() > 0:
        devx.ctrl_transfer(DevID, 0x40, D0.get(), 0, 0, 0, 0, 100) # set PIO 0
    else:
        Dval = devx.ctrl_transfer(DevID, 0xc0, 0x91, 0, 0, 0, 1, 100)
    if D1.get() > 0:
        devx.ctrl_transfer(DevID, 0x40, D1.get(), 1, 0, 0, 0, 100) # set PIO 1
    else:
        Dval = devx.ctrl_transfer(DevID, 0xc0, 0x91, 1, 0, 0, 1, 100)
    if D2.get() > 0:
        devx.ctrl_transfer(DevID, 0x40, D2.get(), 2, 0, 0, 0, 100) # set PIO 2
    else:
        Dval = devx.ctrl_transfer(DevID, 0xc0, 0x91, 2, 0, 0, 1, 100)
    if D3.get() > 0:
        devx.ctrl_transfer(DevID, 0x40, D3.get(), 3, 0, 0, 0, 100) # set PIO 3
    else:
        Dval = devx.ctrl_transfer(DevID, 0xc0, 0x91, 3, 0, 0, 1, 100)
    if D4.get() > 0:
        devx.ctrl_transfer(DevID, 0x40, D4.get(), 4, 0, 0, 0, 100) # set PIO 4
    else:
        Dval = devx.ctrl_transfer(DevID, 0xc0, 0x91, 4, 0, 0, 1, 100)
    if D5.get() > 0:
        devx.ctrl_transfer(DevID, 0x40, D5.get(), 5, 0, 0, 0, 100) # set PIO 5
    else:
        Dval = devx.ctrl_transfer(DevID, 0xc0, 0x91, 5, 0, 0, 1, 100)
    if D6.get() > 0:
        devx.ctrl_transfer(DevID, 0x40, D6.get(), 6, 0, 0, 0, 100) # set PIO 6
    else:
        Dval = devx.ctrl_transfer(DevID, 0xc0, 0x91, 6, 0, 0, 1, 100)
    if D7.get() > 0:
        devx.ctrl_transfer(DevID, 0x40, D7.get(), 7, 0, 0, 0, 100) # set PIO 7
    else:
        Dval = devx.ctrl_transfer(DevID, 0xc0, 0x91, 7, 0, 0, 1, 100)

def ConnectDevice():
    global devx, DevID, bsw1
    try:
        devx = Smu()
        DevID = devx.serials[0]
        print DevID
        bsw1.configure(text="Connected", bg="green")
    except:
        print 'No Device plugged IN!'
        bsw1.configure(text="Reconnect", bg="red")

# setup main window
win1 = Toplevel()
win1.title("D Out")
bsw1 = Button(win1, text="Reconnect", command=ConnectDevice)
bsw1.grid(row=0, column=0, columnspan=2, sticky=W)

D0 = IntVar(0)
D1 = IntVar(0)
D2 = IntVar(0)
D3 = IntVar(0)
D4 = IntVar(0)
D5 = IntVar(0)
D6 = IntVar(0)
D7 = IntVar(0)
rb1 = Radiobutton(win1, text="D0-0", variable=D0, value=0x50, command=sel )
rb1.grid(row=2, column=0, sticky=W)
rb0z = Radiobutton(win1, text="D0-Z", variable=D0, value=0, command=sel )
rb0z.grid(row=2, column=1, sticky=W)
rb2 = Radiobutton(win1, text="D0-1", variable=D0, value=0x51, command=sel )
rb2.grid(row=2, column=2, sticky=W)
rb3 = Radiobutton(win1, text="D1-0", variable=D1, value=0x50, command=sel )
rb3.grid(row=3, column=0, sticky=W)
rb3z = Radiobutton(win1, text="D1-Z", variable=D1, value=0, command=sel )
rb3z.grid(row=3, column=1, sticky=W)
rb4 = Radiobutton(win1, text="D1-1", variable=D1, value=0x51, command=sel )
rb4.grid(row=3, column=2, sticky=W)
rb5 = Radiobutton(win1, text="D2-0", variable=D2, value=0x50, command=sel )
rb5.grid(row=4, column=0, sticky=W)
rb5z = Radiobutton(win1, text="D2-Z", variable=D2, value=0, command=sel )
rb5z.grid(row=4, column=1, sticky=W)
rb6 = Radiobutton(win1, text="D2-1", variable=D2, value=0x51, command=sel )
rb6.grid(row=4, column=2, sticky=W)
rb7 = Radiobutton(win1, text="D3-0", variable=D3, value=0x50, command=sel )
rb7.grid(row=5, column=0, sticky=W)
rb7z = Radiobutton(win1, text="D3-Z", variable=D3, value=0, command=sel )
rb7z.grid(row=5, column=1, sticky=W)
rb8 = Radiobutton(win1, text="D3-1", variable=D3, value=0x51, command=sel )
rb8.grid(row=5, column=2, sticky=W)
rb9 = Radiobutton(win1, text="D4-0", variable=D4, value=0x50, command=sel )
rb9.grid(row=6, column=0, sticky=W)
rb9z = Radiobutton(win1, text="D4-Z", variable=D4, value=0, command=sel )
rb9z.grid(row=6, column=1, sticky=W)
rb10 = Radiobutton(win1, text="D4-1", variable=D4, value=0x51, command=sel )
rb10.grid(row=6, column=2, sticky=W)
rb11 = Radiobutton(win1, text="D5-0", variable=D5, value=0x50, command=sel )
rb11.grid(row=7, column=0, sticky=W)
rb11z = Radiobutton(win1, text="D5-Z", variable=D5, value=0, command=sel )
rb11z.grid(row=7, column=1, sticky=W)
rb12 = Radiobutton(win1, text="D5-1", variable=D5, value=0x51, command=sel )
rb12.grid(row=7, column=2, sticky=W)
rb13 = Radiobutton(win1, text="D6-0", variable=D6, value=0x50, command=sel )
rb13.grid(row=8, column=0, sticky=W)
rb13z = Radiobutton(win1, text="D6-Z", variable=D6, value=0, command=sel )
rb13z.grid(row=8, column=1, sticky=W)
rb13 = Radiobutton(win1, text="D6-1", variable=D6, value=0x51, command=sel )
rb13.grid(row=8, column=2, sticky=W)
rb14 = Radiobutton(win1, text="D7-0", variable=D7, value=0x50, command=sel )
rb14.grid(row=9, column=0, sticky=W)
rb14z = Radiobutton(win1, text="D7-Z", variable=D7, value=0, command=sel )
rb14z.grid(row=9, column=1, sticky=W)
rb15 = Radiobutton(win1, text="D7-1", variable=D7, value=0x51, command=sel )
rb15.grid(row=9, column=2, sticky=W)
# Setup ADAML1000
ConnectDevice()
# start main loop
#root.mainloop()
